#include <stdio.h>
#include <stdlib.h>

/*
 * int hangi_int(const char *sonum) - Küsi kasutajalt int koos sõnumiga
 * 
 * sonum - sõnum, mida kasutajale kuvatakse
 * 
 * return - kasutaja poolt sisestatud täisarv
 */
int hangi_int(const char *sonum)
{
	int v = 0;
	puts(sonum);
	scanf("%d", &v);
	return v;
}

/*
 * int oiged_andmed(int paev, int kuu, int aasta) - kontrolli, kas kuupäev on korrektne
 * 
 * paev, kuu, aasta - kuupäev, mida kontrollida
 * 
 * return - 1, kui kuupäev on korrektne
 */
int oiged_andmed(int paev, int kuu, int aasta)
{
	const int kuupikkused[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	if (aasta >= 1900 && kuu >= 1 && kuu <= 12 && paev >= 1)
	{
		if (kuu == 2)
		{
			if (paev <= 28)
			{
				return 1;
			}
			if (paev == 29 && 
				(aasta % 400 == 0 || (aasta % 4 == 0 && aasta % 100 != 0)))
			{
				return 1;
			}
		}
		else
		{
			return paev <= kuupikkused[kuu - 1];
		}
	}
	return 0;
}

/*
 * void prindi_inimene(char *inimene, int nadalapaev) - 
 */ 
void prindi_inimene(char *inimene, int nadalapaev)
{
	(void)nadalapaev;
	char eesnimi[128];
	char perenimi[128];
	int synnipaev;
	int synnikuu;
	int synniaasta;
	sscanf(inimene, "%s %s %d,%d,%d", 
		eesnimi, 
		perenimi, 
		&synnipaev, 
		&synnikuu, 
		&synniaasta);  //Loeme muutujasse inimene eesnime perenime, sünnikuupäeva
	printf("'%s' '%s' '%d' '%d' '%d'\n", eesnimi, perenimi, synnipaev, synnikuu, synniaasta);
	if (oiged_andmed(synnipaev, synnikuu, synniaasta))
	{
		
	}
	else
	{
		printf("%s %s: kuupäev %d/%d/%d on vale\n", eesnimi, perenimi, synnipaev, synnikuu, synniaasta);
	}
}

void prindi_synnipaevad(FILE *fail, int nadalapaev)
{
	char buffer[512];
	while (!feof(fail))
	{
		fgets(buffer, 512, fail);
		prindi_inimene(buffer, nadalapaev);
	}
}

int main(void)
{	
	int nadalapaev;
	FILE *c1_fail;
	nadalapaev = hangi_int("Sisestada nädalapäev X (arv):");
	c1_fail = fopen("c1.txt", "r");
	if (c1_fail == NULL)
	{
		//Fail ei eksisteeri, või pole avatav. !c1_fail on sama mis c1_fail == NULL
		return 1;
	}
	prindi_synnipaevad(c1_fail, nadalapaev);
	fclose(c1_fail);
	return 0;
}
